#!/usr/bin/ruby -w

# By Dafydd Harries <daf@muse.19inch.net>

count = Hash.new(0)

$stdin.each { |line|
	line.scan(/[A-Za-z0-9]+/).each { |word| count[word.downcase] += 1 }
}

count.keys.sort { |a,b|
	(count[a] != count[b]) ? (count[b] <=> count[a]) : (a <=> b)
}[0, $*[0].to_i].each { |word|
	puts "#{count[word]} #{word}"
}

