BEGIN {
    FS="[^a-zA-Z0-9]+"
    N = ARGV[1]
    delete ARGV[1]
}

{
    for (i = 1; i <= NF; ++i) count[tolower($i)]++
}

END {
    tablen = 0
    tab[0] = ""
    for (word in count)
        if (word != "")
            tablen = isort(count, tab, tablen, word)
    
    for (i = 0; i < tablen; ++i) 
        print count[tab[i]], tab[i]
}

function isort(count, tab, tablen, word) {
    if (tablen == 0) {
        tab[tablen] = word
        return 1
    } else {
        wcount = count[word]
        for (i = tablen; i > 0; --i) {
            icount = count[tab[i-1]]
            if (wcount < icount)
                break
            if (wcount == icount && word > tab[i-1])
                break
            tab[i] = tab[i-1]
        }
        tab[i] = word
        if (tablen < N)
            return tablen + 1
        else
            return tablen
   }
}
